#include <stdio.h>
#include <linux/soundcard.h>
#include <sys/ioctl.h>
#include <fcntl.h>

int main(int argc, char **argv) {
	int base_volume = 50;
	char *mixer_device = "/dev/mixer";
	int mixer;

	if (argc > 1) {
		base_volume = atoi(argv[1]);
		if (base_volume > 100) base_volume = 100;
		if (base_volume < 0) base_volume = 0;
	}
	int oss_volume = base_volume | (base_volume << 8); // set volume for both channels
	mixer = open(mixer_device, O_WRONLY);
	if (ioctl(mixer, SOUND_MIXER_WRITE_VOLUME, &oss_volume) == -1) {
		fprintf(stderr, "Failed opening mixer for write - VOLUME\n");
		return 1;
	}
	fprintf(stderr, "Volume set to %d%\n", base_volume);
	close(mixer);
}
